Lua_MainLineChapterListWindow = class("Lua_MainLineChapterListWindow", Lua_Window);
function Lua_MainLineChapterListWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MainLineChapterListWindow";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.blackAlpha = 0.1;
	self.isClickClose = true;
end

function Lua_MainLineChapterListWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.winBg = UICreate.createUIAtlasImage(self.content, "main_line_altas", "xui_zxtt_window_28", -248, -301, 221, 170);
	self.winBg.anchorValue = 1;

	self.chapterList = Lua_DragList.new(self.content, 212, 155, Lua_AxisDefine.Vertical);
	self.chapterList:setRectAnchor(1);
	self.chapterList:setRectPivot(1);
	self.chapterList:setLocation(-248, -222, 0);
	self.chapterList.tweenId = 2004;
	self.chapterList.delayTween = true;
	self.chapterList:setListCell(Lua_MainLineChapterItem, 212, 40, 1);
end

function Lua_MainLineChapterListWindow:dispose()
	Lua_MsgUtil.callFunc("MAINLINE_CHAPTER_LIST_CLOSE");
	if self.chapterList ~= nil then
		self.chapterList:dispose();
		self.chapterList = nil;
	end
	self:superCall("dispose");
end

function Lua_MainLineChapterListWindow:showWin(param)
	self:superCall("showWin", param);

	local chapterId = DataCenter.mainLineData.curChapterId;
	local arr = DataCenter.mainLineUtil:getChapterIdArr(chapterId);
	local len = arr:getSize();
	local index
	for i = 1, len do
		if arr[i] == param then
			index = i
			break
		end
	end
	index = index == nil and len or index

	self.chapterList.customParam = param;
	self.chapterList.canDrag = len > 4;
	self.chapterList:setArrayData(arr);
	self.chapterList:moveToIndex(index, true, true);
end




















Lua_MainLineChapterItem = class("Lua_MainLineChapterItem", Lua_ListCell);
function Lua_MainLineChapterItem:ctor(p)
	self:superCall("ctor", p, "MainLineChapterItem_skin");
end

function Lua_MainLineChapterItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_MainLineChapterItem:dispose()
	self.customParam = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_MainLineChapterItem:setCustomParam(customParam)
	self.customParam = customParam;
end

function Lua_MainLineChapterItem:setData(chapterId)
	self.data = chapterId;

	local data = Lua_MainLineChapterConfigData.getConfig(chapterId);
	self.nameText.text = LanUtil.formateStr(307001, tostring(chapterId), data.name);

	local curChapterId = DataCenter.mainLineData.curChapterId;
	self.nameText:setGray(chapterId > curChapterId);
	self.lockIcon:setEnable(chapterId > curChapterId);

	if chapterId == self.customParam then
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("FCE567");
	else
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
	end
end

function Lua_MainLineChapterItem:onPressClick()
	if self.data == nil or self.data > DataCenter.mainLineData.curChapterId then
		OperateAlert.showLangValue(307013);
		return;
	end
	if not DataCenter.mainLineCamActController.bActComplete then
		OperateAlert.showLangValue(307012);
		return;
	end
	Lua_MsgUtil.callFunc("MAINLINE_CHAPTER_SELECT", self.data);
	Lua_WindowUtil.openWin("Lua_MainLineChapterListWindow", Lua_WinParam.ACTION_CLOSE);
end