-- 玩法
Lua_MainLinePlayWindow = class("Lua_MainLinePlayWindow", Lua_Window);
function Lua_MainLinePlayWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MainLinePlayWindow";
	self.skinName = "MainLinePlayWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_MainLinePlayWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 720, 371, Lua_AxisDefine.Horizontal);
	self.itemList:setLocation(0, 63, 0);
	self.itemList:setListCell(Lua_MainLinePlayItem, 240, 371, 1);
	self.itemList.canDrag = false;
	self.itemList:setArrayData(getConfig("mainline_play_info"));
end

function Lua_MainLinePlayWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_MainLinePlayWindow:showWin(param)
	self:superCall("showWin", param);
	self.promptText.text = LanUtil.formateStr(307014, tostring(param));
end




















Lua_MainLinePlayItem = class("Lua_MainLinePlayItem", Lua_ListCell);
function Lua_MainLinePlayItem:ctor(p)
	self:superCall("ctor", p, "MainLinePlayItem_skin");
end

function Lua_MainLinePlayItem:buildShowItem()
	self:superCall("buildShowItem");
	self.btnGoto:addClickFuntion(self, self.onGotoBtnClick);
end

function Lua_MainLinePlayItem:dispose()
	self:stopTimer();
	self.data = nil;
	self:superCall("dispose");
end

function Lua_MainLinePlayItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.tagText.text = data.tag;
	self.nameText.text = data.name;
	self.icon:setAltas(data.icon_altas, data.icon_sprite);
	self.icon:resetSize()

	if data.id == 1 then
		self:startTimer();
		self.icon:setLocation(1, 62, 0)
		self.dataText.text = Lua_TimeTransform.transSeconds6(DataCenter.hookData.show_hook_time);
	elseif data.id == 2 then
		self:stopTimer();
		self.icon:setLocation(-4.5, 52.5, 0)
		local leftTimes = DataCenter.hookData.free_times + DataCenter.hookData.buy_times;
		local free_times = DataCenter.mainLineUtil.free_publicity_times;
		local pay_times = DataCenter.mainLineUtil.pay_publicity_times;
		local extra_times = DataCenter.personReadData.quick_fight_gain_range;
		local totalTimes = free_times + pay_times + extra_times
		self.dataText.text = LanUtil.formateStr(307015, tostring(leftTimes), tostring(totalTimes));
	elseif data.id == 3 then
		self:stopTimer();
		self.icon:setLocation(2, 62, 0)
		local value = DataCenter.climbTowerData:getTowerVoById(Lua_ClimbTowerUtil.LIGHT_ID).cur_storey;
		self.dataText.text = LanUtil.formateStr(307016, tostring(value));
	end
end

function Lua_MainLinePlayItem:startTimer()
	if self.bTiming ~= true then
		self.bTiming = true;
		self:addTimer("Lua_MainLinePlayItem", 1, self, self.onTimer, nil, -1);
	end
end

function Lua_MainLinePlayItem:stopTimer()
	if self.bTiming == true then
		self.bTiming = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_MainLinePlayItem:onTimer()
	self.dataText.text = Lua_TimeTransform.transSeconds6(DataCenter.hookData.show_hook_time);
end

function Lua_MainLinePlayItem:onGotoBtnClick(go)
	if self.data == nil then
		return;
	end

	if self.data.id == 1 then
		local openId = DataCenter.mainLineUtil.hook_open_id;
		if not DataCenter.funcOpenData:isOpened(openId, true) then
			return;
		end

		if DataCenter.hookData.show_hook_time <= 60 then
			OperateAlert.showLangValue(307010);
			return;
		end
		
		Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sHookRewardReceive(0);
	elseif self.data.id == 2 then
		Lua_WindowUtil.openWin("Lua_FastFightWindow", Lua_WinParam.ACTION_OPEN);
	elseif self.data.id == 3 then
		DataCenter.funcPathUtil:gotoFunction(1030)
	end
	Lua_WindowUtil.openWin("Lua_MainLinePlayWindow", Lua_WinParam.ACTION_CLOSE);
end