Lua_MainLineRewardWindow = class("Lua_MainLineRewardWindow", Lua_Window)
function Lua_MainLineRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MainLineRewardWindow";
	self.skinName = "MainLineRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_MainLineRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 630, 760, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, -85, 0);
	self.itemList.tweenId = 2004;
	self.itemList:setListCell(Lua_MainLineRewardItem, 630, 165, 1);
	self.itemList:setCellSpacing(0, 5);
	
	self:addLuaEvent("MAINLINE_REWARD_RECEIVE_UPDATE", self, self.updateShowInfo);
	self:updateShowInfo();
end

function Lua_MainLineRewardWindow:dispose()
	if self.itemList then
		self.itemList:dispose()
		self.itemList = nil
	end
	self:superCall("dispose");
end

function Lua_MainLineRewardWindow:updateShowInfo()
	self.itemList:setArrayData(DataCenter.mainLineUtil.rewardArr);
end




















Lua_MainLineRewardItem = class("Lua_MainLineRewardItem", Lua_ListCell)
function Lua_MainLineRewardItem:ctor(p)
	self:superCall("ctor", p, "MainLineRewardItem_skin");
end

function Lua_MainLineRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 280, 100, Lua_AxisDefine.Horizontal);
	self.itemList:setRectPivot(3);
	self.itemList:setLocation(-300, -17);
	self.itemList:setListCell(Lua_ItemIconCell2, 100, 100, 1);
	self.itemList:setCellSpacing(10, 0);
	self:setSubList(self.itemList);

	self.btnFunc:addClickFuntion(self, self.onFuncBtnClick);
end

function Lua_MainLineRewardItem:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_MainLineRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local config = Lua_MainLineCheckpointConfigData.getConfig(data);
	self.titleText.text = LanUtil.formateStr(307017, tostring(config.chapter_id), tostring(config.level));

	local rState = DataCenter.mainLineData:getCheckpointReceiveState(data);
	if rState == 2 then
		self.btnFunc:setEnable(false);
		self.receiveIcon:setEnable(true);
		self:showRedDot(false);
	elseif rState == 1 then
		self.btnFunc:setEnable(true);
		self.btnFunc:setStyle(1);
		self.btnFunc:setLangValue(307018);
		self.receiveIcon:setEnable(false);
		self:showRedDot(true);
	else
		self.btnFunc:setEnable(true);
		self.btnFunc:setStyle(3);
		self.btnFunc:setLangValue(307019);
		self.receiveIcon:setEnable(false);
		self:showRedDot(false);
	end

	config = Lua_RewardConfigData.getConfigDataById(config.reward_id);
	self.itemList.canDrag = #config.client_show > 2;
	self.itemList:setArrayData(config.client_show);
	self.itemList:moveToIndex(1, true);
end

function Lua_MainLineRewardItem:showRedDot(bValue)
	if bValue then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(280, 20, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_MainLineRewardItem:onFuncBtnClick(go)
	if self.data == nil then
		return;
	end
	
	local rState = DataCenter.mainLineData:getCheckpointReceiveState(self.data);
	if rState == 1 then
		Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sReceiveReward(self.data);
	else
		Lua_WindowUtil.openWin("Lua_MainLineRewardWindow", Lua_WinParam.ACTION_CLOSE);
	end
end