-- 快速作战
checkRequire("Lua_HookIncomeSpeedItem");
Lua_FastFightWindow = class("Lua_FastFightWindow", Lua_Window);
function Lua_FastFightWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FastFightWindow";
	self.skinName = "FastFightWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_FastFightWindow:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("UPDATE_HOOK_INFO", self, self.updateShowInfo);

	self.itemList = Lua_DragList.new(self.content, 620, 200, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(1, -250, 0);
	self.itemList.tweenId = 2003;
	self.itemList:setListCell(Lua_FastFightRewardItem, 112, 112, 5);
	self.itemList:setCellSpacing(15, 20);

	self.redPointIcon = Lua_RedPointIcon.new(self.content, Lua_RedPointList.MainLine_Privilege);
	self.redPointIcon:setLocation(300, -415);

	self.btnFastFight:addClickFuntion(self, self.onFastFightClick);
	self.checkPrivilege:addClickFuntion(self, self.onCheckPrivilege);

	self:updateProfit();
	self:updateShowInfo();
end

function Lua_FastFightWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.redPointIcon then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	if self.profitArr ~= nil then
		self.profitArr:dispose();
		self.profitArr:clear();
		self.profitArr = nil;
	end
	if self.costIconItem ~= nil then
		self.costIconItem:dispose();
		self.costIconItem = nil;
	end
	self:superCall("dispose");
end

function Lua_FastFightWindow:updateProfit()
	if self.profitArr == nil then
		self.profitArr = Array();
	end
	local profit_rate = DataCenter.hookData.profit_rate;
	local num = (profit_rate == nil) and 0 or #profit_rate;
	local len = self.profitArr:getSize();
	local maxLen = num > len and num or len;
	local item;
	local posX;
	local posY;
	for i = 1, maxLen do
		item = self.profitArr[i];
		if i > num then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_HookIncomeSpeedItem.new(self.content);
				self.profitArr:add(item);
			end
			item:setEnable(true);
			posX = -159 + ((i - 1) % 2) * 310;
			posY = 25 + Mathf.Floor((i - 1) / 2) * -71;
			item:setLocation(posX, posY, 0);
			item:setData(profit_rate[i]);
		end
	end
end

function Lua_FastFightWindow:updateShowInfo()
	local time = DataCenter.mainLineUtil.one_hook_earnings_time;
	local freeTimes = DataCenter.mainLineUtil.free_publicity_times;
	local buyTimes = DataCenter.mainLineUtil.pay_publicity_times;

	self.des_1.text = LanUtil.formateStr(307029, tostring(time));
	self.des_2.text = LanUtil.formateStr(307030, tostring(freeTimes), tostring(buyTimes));

	local data = DataCenter.hookData;
	local tab = DataCenter.packData:getRewardDic(data.all_reward);
	local arr = DataCenter.packData:getRewardList(tab);
	arr:sortf(self, self.onRewardSort);
	self.itemList:setArrayData(arr);

	if data.free_times > 0 then
		self.btnFastFight:setBtnEnable(true);
		self.btnFastFight:setLangValue(307031);
		if self.costIconItem ~= nil then
			self.costIconItem:setEnable(false);
		end
	elseif data.buy_times > 0 then
		self.btnFastFight:setBtnEnable(true);
		self.btnFastFight.label = nil;
		if self.costIconItem == nil then
			self.costIconItem = Lua_ConsumeIconItem.new(self.content);
			self.costIconItem:setLocation(0, -420, 0);
			self.costIconItem:setStyle(Lua_MyUISettings.huakangFontName, 34);
		end
		self.costIconItem:setEnable(true);
		local itemVo = Lua_ResourcesData.getConfigDataById(Lua_ResourcesDefine.DIAMOND).itemVo;
		self.costIconItem:setData(itemVo, nil, LanUtil.formateStr(307032, tostring(data.fastFightConsume)));
	else
		self.btnFastFight:setBtnEnable(false);
		self.btnFastFight:setLangValue(307036);
		if self.costIconItem ~= nil then
			self.costIconItem:setEnable(false);
		end
	end
	self.leftTimes.text = LanUtil.formateStr(307033, tostring(data.free_times + data.buy_times));
end

function Lua_FastFightWindow:onRewardSort(a, b)
	a = DataCenter.mainLineUtil:getRewardSortValue(a);
	b = DataCenter.mainLineUtil:getRewardSortValue(b);
	if a < b then
		return false;
	end
	return true;
end

function Lua_FastFightWindow:onFastFightClick(go)
	self:checkIntelligence();
end

function Lua_FastFightWindow:checkIntelligence()
	if DataCenter.hookData:checkIntelligenceIsOverflow2() then
		local tipsData = { des = LanUtil.getValue(307011), btnType = 1, owner = self, sureFun = self.onCheckFree };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:onCheckFree();
	end
end

function Lua_FastFightWindow:onCheckFree()
	if DataCenter.hookData.free_times > 0 then
		Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sFastFight();
	elseif DataCenter.neverTipData:getNeverValue(Lua_NeverTipDefine.MAINLINE_FASTFIGHT) then
		self:onFastFight();
	else
		local str = spliceIconStrById(Lua_ResourcesDefine.DIAMOND);
		local tipsData = { des = LanUtil.formateStr(307034, str, tostring(DataCenter.hookData.fastFightConsume)), 
		btnType = 1, neverTip = Lua_NeverTipDefine.MAINLINE_FASTFIGHT, owner = self, sureFun = self.onFastFight };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	end
end

function Lua_FastFightWindow:onFastFight()
	if not DataCenter.moneyData:isMoneyEnough(Lua_ResourcesDefine.DIAMOND, DataCenter.hookData.fastFightConsume, true, true) then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sFastFight();
end

function Lua_FastFightWindow:onCheckPrivilege(go)
	self.redPointIcon:clickHandler();
	DataCenter.funcPathUtil:gotoFunction(1083)
	self:hide()
end




















Lua_FastFightRewardItem = class("Lua_FastFightRewardItem", Lua_ItemIconCell)
function Lua_FastFightRewardItem:buildShowItem()
	self:superCall("buildShowItem")

	self.itemIcon:setScale(0.9, 0.9, 1)
end

function Lua_FastFightRewardItem:setData(data)
	self:superCall("setData", data)
	
	self.itemIcon:showNum(data.count, false)
end