Lua_HookIncomeChangeWindow = class("Lua_HookIncomeChangeWindow", Lua_Window)
function Lua_HookIncomeChangeWindow:ctor()
	self:superCall("ctor");
	self.showBlackMask = true;
	self.blackAlpha = 0.01;
	self.windowName = "Lua_HookIncomeChangeWindow";
	self.skinName = "HookIncomeChangeWindow_skin";
end

function Lua_HookIncomeChangeWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HookIncomeChangeWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.hide);
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	self:superCall("dispose");
end

function Lua_HookIncomeChangeWindow:showWin(param)
	self:superCall("showWin", param);

	local config = Lua_MainLineCheckpointConfigData.getConfig(param);
	local chapterCfg = Lua_MainLineChapterConfigData.getConfig(config.chapter_id);
	self.titleName.text = chapterCfg.name..config.name;

	local prevConfig = Lua_MainLineCheckpointConfigData.getConfig(config.prev_game_level_id);
	local list = config.normal_profit;
	if self.itemArr == nil then
		self.itemArr = Array();
	end
	local item;
	for i = 1, #list do
		item = self.itemArr[i];
		if item == nil then
			item = Lua_HookIncomeChangeItem.new(self.content);
			self.itemArr:add(item);
		end
		if prevConfig == nil then
			item:setData(nil, list[i]);
		else
			item:setData(prevConfig.normal_profit[i], list[i]);
		end
		item:setLocation(-11, 118.5 - (i - 1) * 50, 0);
	end

	Lua_CommonUtil.delayCall(2, self, self.hide);
end




















Lua_HookIncomeChangeItem = class("Lua_HookIncomeChangeItem", Lua_DisplayObject)
function Lua_HookIncomeChangeItem:ctor(p)
    self:superCall("ctor", p, "HookIncomeChangeItem_skin");
end

function Lua_HookIncomeChangeItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HookIncomeChangeItem:dispose()
    self:superCall("dispose");
end

function Lua_HookIncomeChangeItem:setData(prevData, curData)
    if prevData == nil then
        self.prevIncome.text = 0;
    else
        self.prevIncome.text = numberTrans(prevData[2]);
    end
    
    if curData == nil then
        self.curIncome.text = LanUtil.formateStr(307042, 0);
    else
        self.curIncome.text = LanUtil.formateStr(307042, numberTrans(curData[2]));
        local tvo = Lua_ToolVo.createToolVo(curData[1]);
        self.icon_1:setAltas(tvo.iconAtlas, tvo.iconSprite);
        self.icon_1:SetDimensions(tvo.iconWidth, tvo.iconHeight);
        self.icon_2:setAltas(tvo.iconAtlas, tvo.iconSprite);
        self.icon_2:SetDimensions(tvo.iconWidth, tvo.iconHeight);
    end
end