Lua_HookIncomePanel = class("Lua_HookIncomePanel", Lua_DisplayObject);
function Lua_HookIncomePanel:ctor(p)
	self:superCall("ctor", p, "HookIncomePanel_skin");
end

function Lua_HookIncomePanel:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("UPDATE_HOOK_INFO", self, self.updateShowInfo);

	self.hook_uplimit_time = 1;
	self.hook_time = 0;
	self.timeBar.typeValue = 3;
	self.timeBar.fillMethodValue = 0;
	self.timeBar.fillOrigin = 0;
	self.timeBar:setMaxValue(self.hook_uplimit_time);
	self.timeBar:setValue(self.hook_time);
	
	self.clickArea:addClickFuntion(self, self.onClick);
	self:updateShowInfo();
end

function Lua_HookIncomePanel:dispose()
	self:stopTimer();
	if self.hookEff ~= nil then
		self.hookEff:dispose();
		self.hookEff = nil;
	end
	if self.modelEffImg then
		self.modelEffImg:dispose();
		self.modelEffImg = nil;
	end
	self:superCall("dispose");
end

function Lua_HookIncomePanel:updateShowInfo()
	self.hook_uplimit_time = DataCenter.hookData.hook_uplimit_time;
	self.hook_time = DataCenter.hookData.show_hook_time;
	if self.hook_time < self.hook_uplimit_time then
		self:startTimer();
	end
	self:updateShowTime();
	self:updateShowEffect();
end

function Lua_HookIncomePanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_HookIncomePanel", 1, self, self.onTimer, nil, -1);
	end
end

function Lua_HookIncomePanel:stopTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_HookIncomePanel:onTimer()
	self.hook_time = DataCenter.hookData.show_hook_time;
	if self.hook_time >= self.hook_uplimit_time then
		self:stopTimer();
		self.hook_time = self.hook_uplimit_time;
	end
	self:updateShowTime();
	self:updateShowEffect();
end

function Lua_HookIncomePanel:updateShowTime()
	self.timeBar:setMaxValue(self.hook_uplimit_time);
	self.timeBar:setValue(self.hook_time);
	self.timeText.text = Lua_TimeTransform.transSeconds6(self.hook_time);
end

function Lua_HookIncomePanel:updateShowEffect()
	local action, name = DataCenter.mainLineUtil:getEffectByTime(self.hook_time);
	if self.modelAct == action then
		return;
	end
	self.modelAct = action;

	if action == 0 or action <= 0 then
		if self.modelEffImg ~= nil then
			self.modelEffImg:setEnable(false);
		end
	else
		if self.modelEffImg == nil then
			self.modelEffImg = UICreate.createModelEffImg(self.content, nil, nil, 0, 0, 0, 0);
			self.modelEffImg.siblingIndex = 0;
			self.modelEffImg:setScale(0.4, 0.4, 1);
			self.modelEffImg:setCamField(1, 1, 100, true);
			self.modelEffImg:setCamPos(0, 1, -10);
			self.modelEffImg.canRot = false;
			self.modelEffImg:addLuaLoadCompleteFun(self, self.onModelLoaded);
			self.modelEffImg:setUrl("/model/role/109000100_low", "109000100_low");
		else
			self.modelEffImg:setEnable(true);
			self:onModelLoaded();
		end
		if action == 101 then
			self.modelEffImg:setLocation(-245, 305, 0);
			self.modelEffImg:setRot(0, 0, -3);
		elseif action == 102 then
			self.modelEffImg:setLocation(-245, 305, 0);
			self.modelEffImg:setRot(0, 0, -3);
		elseif action == 103 then
			self.modelEffImg:setLocation(-245, 308, 0);
			self.modelEffImg:setRot(0, 0, -2);
		else
			self.modelEffImg:setLocation(-245, 320, 0);
			self.modelEffImg:setRot(0, 0, 0);
		end
	end
	
	if strIsNullOrEmpty(name) then
		if self.hookEff ~= nil then
			self.hookEff:setEnable(false);
		end
	else
		if self.hookEff == nil then
			self.hookEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_zx_gjsy", name, 0, 0);
			self.hookEff.siblingIndex = 1;
		else
			self.hookEff:setEnable(true);
			self.hookEff:setUrl("/effects/uiEffects/ui_zx_gjsy", name);
		end
		if name == "ui_zx_gjsy_1" then
			self.hookEff:setLocation(-270, 165, 0);
		elseif name == "ui_zx_gjsy_2" then
			self.hookEff:setLocation(-277, 175, 0);
		else
			self.hookEff:setLocation(-265, 178, 0);
		end
	end
end

function Lua_HookIncomePanel:onModelLoaded()
	self.modelEffImg:setAction(self.modelAct);
	self.modelEffImg:removeHangerEff();
	if self.modelAct == 101 then
		self.modelEffImg:addHangerEff("xiong_benpao");
		self.modelEffImg:setModelEffDir(115);
	elseif self.modelAct == 102 then
		self.modelEffImg:setModelEffDir(105);
	elseif self.modelAct == 103 then
		self.modelEffImg:addHangerEff("jinbipaosa");
		self.modelEffImg:setModelEffDir(85);
	else
		self.modelEffImg:setModelEffDir(80);
	end
end

function Lua_HookIncomePanel:onClick(go)
	local openId = DataCenter.mainLineUtil.hook_open_id;
	if not DataCenter.funcOpenData:isOpened(openId, true) then
		return;
	end

	if self.hook_time <= 60 then
		OperateAlert.showLangValue(307010);
		return;
	end
	
	Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sHookRewardReceive(0);
end