Lua_OnLineEnterPanel = class("Lua_OnLineEnterPanel", Lua_DisplayObject);
function Lua_OnLineEnterPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_OnLineEnterPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.onlineBg = UICreate.createUIAtlasImage(self.content, "online_atlas", "xui_zxjl_widget_2", -296, -564, 0, 0);
	self.onlineBg.anchorValue = 1;
	self.onlineBg:addClickFuntion(self, self.onOpenWinClick);

	self.itemIcon = UICreate.createUIAtlasImage(self.content, "", "", -296, -564, 0, 0);
	self.itemIcon.anchorValue = 1;
	self.itemIcon:setScale(0.76, 0.76);

	self.onlineEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_zxjl_0101", "ui_ty_zxjl_0101", -296, -564);
	self.onlineEff.anchorValue = 1;

	self.drawIcon = UICreate.createUIAtlasImage(self.content, "online_atlas", "xui_zxjl_button_1", -296, -626, 0, 0);
	self.drawIcon.anchorValue = 1;

	self.onlineTxt = UICreate.createLabel(self.content, nil, -296, -626, 100, 0, 24);
	self.onlineTxt.anchorValue = 1;
	self.onlineTxt.pivotValue = 4;
	self.onlineTxt.alignmentValue = 4;
	self.onlineTxt.effectStyle = 2;
	self.onlineTxt.effectColorStr = Lua_ColorDefine.transColor("292A32");
	self.onlineTxt:setEffectDistance(2, 2);
	
	self.online_redPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.MainLine_OnLine);
	self.online_redPoint:setLocation(-258, -533, 0);
	self.online_redPoint:setRectAnchor(1);

	self:addLuaEvent("UPDATA_ONLINE_REWARD", self, self.updateOnlineInfo);
	self:updateOnlineInfo();
end

function Lua_OnLineEnterPanel:updateOnlineInfo()
	local data = DataCenter.onlineRewardData;
	local rewardVo = DataCenter.onlineRewardUtil.onlineRewardArr[data.curIdx].rewardVo;
	self.itemIcon:setAltas(rewardVo.atlas, rewardVo.sprite);

	if data.receiveVo == nil and data.timeVo == nil then
		self.onlineBg:setEnable(false);
		self.itemIcon:setEnable(false);
		self.onlineEff:setEnable(false);
		self.drawIcon:setEnable(false);
		self.onlineTxt:setEnable(false);
		self:endTimer();
	else
		if data.receiveVo == nil then
			self.onlineEff:setEnable(false);
			self.drawIcon:setEnable(false);
			self.onlineTxt:setEnable(true);

			self.remainTime = data.timeVo.remainTime;
			self:startTimer();
			self:updateTimer();
		else
			self.onlineEff:setEnable(true);
			self.drawIcon:setEnable(true);
			self.onlineTxt:setEnable(false);
			self:endTimer();
		end
	end
end

function Lua_OnLineEnterPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		Lua_CommonUtil.addTimer("Lua_OnLineEnterPanel", 1, self, self.updateTimer);
	end
end

function Lua_OnLineEnterPanel:updateTimer()
	self.remainTime = self.remainTime - 1;
	if self.remainTime <= 0 then
		self:endTimer();
	end
	self.onlineTxt.text = TimeTransform.getInstance():transSeconds6(self.remainTime, true, true);
end

function Lua_OnLineEnterPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateTimer);
	end
end

function Lua_OnLineEnterPanel:onOpenWinClick(go)
	Lua_WindowUtil.openWin("Lua_OnLineRewardWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_OnLineEnterPanel:dispose()
	if self.onlineBg ~= nil then
		self.onlineBg:dispose();
		self.onlineBg = nil;
	end
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.onlineEff ~= nil then
		self.onlineEff:dispose();
		self.onlineEff = nil;
	end
	if self.drawIcon ~= nil then
		self.drawIcon:dispose();
		self.drawIcon = nil;
	end
	if self.onlineTxt ~= nil then
		self.onlineTxt:dispose();
		self.onlineTxt = nil;
	end
	if self.online_redPoint ~= nil then
		self.online_redPoint:dispose();
		self.online_redPoint = nil;
	end
	self:endTimer();
	self:superCall("dispose");
end