-- 在线奖励
Lua_OnLineRewardWindow = class("Lua_OnLineRewardWindow", Lua_Window);
function Lua_OnLineRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_OnLineRewardWindow";
	self.skinName = "OnLineRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.winBgPath = "/images/online/xui_zxjl_widget_1.png";

	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_OnLineRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.showList = Lua_DragList.new(self.content, 568, 555, Lua_AxisDefine.Vertical);
	self.showList.tweenId = 2016;
	self.showList:setListCell(Lua_OnLineRewardItem, 142, 126, 4);
	self.showList:setCellSpacing(0, 17);
	self.showList:setLocation(0, -42, 0);

	self:addLuaEvent("UPDATA_ONLINE_REWARD", self, self.updateShowInfo);
	Lua_ProxyManager.getProxy("Lua_OnlineRewardProxy"):sOnlineInfo();
end

function Lua_OnLineRewardWindow:updateShowInfo()
	self.showList:setArrayData(DataCenter.onlineRewardUtil.onlineRewardArr);
	self.showList:moveToIndex(DataCenter.onlineRewardData.curIdx);

	local vo = DataCenter.onlineRewardData.timeVo;
	if vo == nil then
		self:endTimer();
	else
		self.remainTime = vo.remainTime;
		self:startTimer();
		self:onTimer();
	end
end

function Lua_OnLineRewardWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		Lua_CommonUtil.addTimer("Lua_OnLineRewardWindow", 1, self, self.onTimer);
	end
end

function Lua_OnLineRewardWindow:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onTimer);
	end
	self.timeTxt.text = LanUtil.formateStr(130101, Lua_TimeTransform.transSeconds6(0, true, true, true));
end

function Lua_OnLineRewardWindow:onTimer()
	self.remainTime = self.remainTime - 1;
	if self.remainTime <= 0 then
		self.remainTime = 0;
		self:endTimer();
	end
	self.timeTxt.text = LanUtil.formateStr(130101, Lua_TimeTransform.transSeconds6(self.remainTime, true, true, true));
end

function Lua_OnLineRewardWindow:dispose()
	if self.showList ~= nil then
		self.showList:dispose();
		self.showList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end










Lua_OnLineRewardItem = class("Lua_OnLineRewardItem", Lua_ListCell)
function Lua_OnLineRewardItem:ctor(p)
	self:superCall("ctor", p, "OnLineRewardItem_skin");
end

function Lua_OnLineRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.getIcon:setEnable(false);
	self.lockIcon:setEnable(false);
	self.lockBg:setEnable(false);

	self.rewardItem = Lua_ItemIcon.new(self.content);
	self.rewardItem:setSiblingIndex(1);
	self.rewardItem:setScale(0.9, 0.9);
end

function Lua_OnLineRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.rewardItem:setData(data.rewardVo);
	self.rewardItem:setDrawMask(data.isReceive);

	-- self.lockBg:setEnable(data.remainTime > 0);
	self:showEffect(not data.isReceive and data.remainTime == 0);
end

function Lua_OnLineRewardItem:showEffect(isShow)
	if isShow then
		if self.uiEffect == nil then
			self.uiEffect = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
		end
		self.uiEffect:setUrl("/effects/uiEffects/ui_ty_zxjl_0102", "ui_ty_zxjl_0102");
		self.uiEffect:setEnable(false);
		self.uiEffect:setEnable(true);
	else
		if self.uiEffect ~= nil then
			self.uiEffect:setEnable(false);
		end
	end
end

function Lua_OnLineRewardItem:onPressClick()
	if self.data.isReceive or self.data.remainTime > 0 then
		DataCenter.packUtil:showItemInfo(self.data.rewardVo);
	else
		if self.data.prev_id == 0 or DataCenter.onlineRewardData:getReceiveStateById(self.data.prev_id) then
			Lua_ProxyManager.getProxy("Lua_OnlineRewardProxy"):sReceive(self.data.id);
		else
			OperateAlert.showLangValue(130100);
		end	
	end
end

function Lua_OnLineRewardItem:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	if self.uiEffect ~= nil then
		self.uiEffect:dispose();
		self.uiEffect = nil;
	end
	self.data = nil;
	
	self:superCall("dispose");
end